import javax.swing.*;
import java.awt.*;

public class Gallery extends JFrame {
	
	public Gallery() {
		super("Gallery");
		
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new FlowLayout(FlowLayout.LEFT));

		// JLabel
		JLabel label = new JLabel("Hello, world.");
		add(label);
		
		// JButton
		JButton button = new JButton("Click me.");
		add(button);
		
		// JTextField
		JTextField textField = new JTextField("single line input");
		add(textField);
		
		// JTextArea
		JTextArea textArea = new JTextArea("multi line input",4,12);
		textArea.setLineWrap(true);
		add(textArea);
		
		// radio buttons
		ButtonGroup buttonGroup = new ButtonGroup();
		JRadioButton radioButton1 = new JRadioButton("option 1");
		JRadioButton radioButton2 = new JRadioButton("option 2");
		JRadioButton radioButton3 = new JRadioButton("option 3");
		JRadioButton radioButton4 = new JRadioButton("option 4");
		buttonGroup.add(radioButton1);
		buttonGroup.add(radioButton2);
		buttonGroup.add(radioButton3);
		buttonGroup.add(radioButton4);
	    // put the radio buttons in a panel
		JPanel radioPanel = new JPanel(new GridLayout(0,1));
		radioPanel.add(radioButton1);
		radioPanel.add(radioButton2);
		radioPanel.add(radioButton3);
		radioPanel.add(radioButton4);
		add(radioPanel);
		
		// JTable
		int numRows = 3;
		int numCols = 3;
		JTable table = new JTable(numRows,numCols);
		for (int i=0; i<numRows; i++)
			for (int j=0; j<numCols; j++)
				table.setValueAt("("+i+","+j+")",i,j);
		add(table);
		
		// JList
		String[] data = {"one", "two", "three", "four"};
	    JList list = new JList(data);
		add(list);
		
		// checkboxes
		JPanel checkboxPanel = new JPanel();
		checkboxPanel.setLayout(new BoxLayout(checkboxPanel,BoxLayout.Y_AXIS));
		JCheckBox cBox1 = new JCheckBox("check 1");
		JCheckBox cBox2 = new JCheckBox("check 2");
		JCheckBox cBox3 = new JCheckBox("long check 3");
		JCheckBox cBox4 = new JCheckBox("very long check 4");
		checkboxPanel.add(cBox1);
		checkboxPanel.add(cBox2);
		checkboxPanel.add(cBox3);
		checkboxPanel.add(cBox4);
		add(checkboxPanel);
		
		JSlider slider = new JSlider(JSlider.VERTICAL,0,100,50);
		add(slider);
		
		SpinnerNumberModel spinnerModel = new SpinnerNumberModel(0,0,999,1);
		JSpinner spinner = new JSpinner(spinnerModel);
		add(spinner);
		
		pack();
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new Gallery();
	}
}
